package sun.net.www.protocol.file;

import sun.net.www.ParseUtil;
import java.net.Proxy;
import java.io.IOException;
import java.net.URLConnection;
import java.io.File;
import java.net.URL;
import java.net.URLStreamHandler;

public class Handler extends URLStreamHandler
{
    public Handler() {
    }
    
    private String getHost(URL url) {
        String host = url.getHost();
        if (host == null) {
            host = "";
            return host;
        }
        return host;
    }
    
    @Override
    protected void parseURL(URL u, String s, int start, int limit) {
        super.parseURL(u, s.replace(File.separatorChar, '/'), start, limit);
    }
    
    public synchronized URLConnection openConnection(URL url) throws IOException {
        return this.openConnection(url, null);
    }
    
    public synchronized URLConnection openConnection(URL url, Proxy proxy) throws IOException {
        String file = url.getFile();
        String host = url.getHost();
        String replace = ParseUtil.decode(file).replace('/', '\\').replace('|', ':');
        if (host == null || host.equals("") || host.equalsIgnoreCase("localhost") || host.equals("~")) {
            return this.createFileURLConnection(url, new File(replace));
        }
        String string = "\\\\" + host + replace;
        File file2 = new File(string);
        if (file2.exists()) {
            return new UNCFileURLConnection(url, file2, string);
        }
        URLConnection urlConnection;
        try {
            URL o = new URL("ftp", host, file + ((url.getRef() == null) ? "" : ("#" + url.getRef())));
            if (proxy != null) {
                urlConnection = o.openConnection(proxy);
            }
            else {
                urlConnection = o.openConnection();
            }
        }
        catch (IOException ex) {
            urlConnection = null;
        }
        if (urlConnection == null) {
            throw new IOException("Unable to connect to: " + url.toExternalForm());
        }
        return urlConnection;
    }
    
    protected URLConnection createFileURLConnection(URL url, File file) {
        return new FileURLConnection(url, file);
    }
    
    @Override
    protected boolean hostsEqual(URL u1, URL u2) {
        String host = u1.getHost();
        String host2 = u2.getHost();
        return ("localhost".equalsIgnoreCase(host) && (host2 == null || "".equals(host2))) || ("localhost".equalsIgnoreCase(host2) && (host == null || "".equals(host))) || super.hostsEqual(u1, u2);
    }
}
